*,
*::after,
*::before {
    box-sizing: border-box;
}

.Carousel {
    margin: 0;
    --carousel-gap: 1rem;
    border-radius: 1rem;
    display: flex;
    gap: var(--carousel-gap);
    overflow-y: hidden;
    overflow-x: auto;
    position: relative;
    scroll-behavior: auto;
    scroll-snap-type: x mandatory;
    scrollbar-width: none;
    -webkit-overflow-scrolling: touch;
    height: 50vw;
    outline: none !important;
    min-height: 20rem;
    max-height: 30rem;

    &::-webkit-scrollbar {
        display: none;
    }

    .Card {
        aspect-ratio: var(--card-ratio);
        flex: 1 0 auto;
        min-height: 100%;
        scroll-snap-align: start;
    }

    .Card__media {
        aspect-ratio: auto;
    }

    &>div:empty {
        position: relative;

        &:first-child {
            inset-inline-start: 10%;
            margin-inline-end: calc(-1 * var(--carousel-gap));
        }

        &:last-child {
            inset-inline-end: 10%;
            margin-inline-start: calc(-1 * var(--carousel-gap));
        }
    }
}

.Carousel--single {
    .Card {
        --card-ratio: auto;
        flex: 1 0 100%;
    }
}

@media (prefers-reduced-motion: reduce) {
    .Carousel {
        scroll-behavior: auto;
    }
}

@supports not (aspect-ratio: 1/1) {
    .Carousel {
        .Card__media {
            padding-block-end: 0 !important;
        }

        .Card__image {
            position: relative !important;
        }
    }
}

.Card {
    --card-ratio: auto 1/1;
    display: grid;
    grid-template-columns: 1fr;
    grid-template-rows: [media-start] auto [media-end main-start] auto [main-end];
    max-width: 100%;
    position: relative;
}

.Card__media {
    aspect-ratio: var(--card-ratio);
    background: hsla(var(--card-background-color), 0.5);
    border-radius: 1rem;
    grid-column: 1 / -1;
    grid-row: media-start / media-end;
    max-width: 100%;
    overflow: hidden;
    position: relative;
    z-index: -1;

    &>* {
        border-radius: inherit;
        height: 100%;
        object-fit: cover;
        position: absolute;
        width: 100%;
    }
}

.Card--overlay {
    --card-shadow-color: var(--theme-black);
    --card-foreground-color: var(--theme-white);
    --card-background-color: var(--theme-dark);
    --card-link-color: var(--theme-white);
    --card-hover-color: var(--theme-white);

    grid-template-rows:
        [media-start] 1fr [overlay-start] 1rem [main-start] auto [main-end overlay-end media-end];

    &::before {
        background: linear-gradient(to top,
                hsla(var(--card-shadow-color), 0.8) 20%,
                hsla(var(--card-shadow-color), 0.3) 60%,
                transparent);
        border-bottom-left-radius: 1rem;
        border-bottom-right-radius: 1rem;
        content: '';
        display: block;
        grid-column: 1 / -1;
        grid-row: overlay-start / overlay-end;
        overflow: hidden;
    }

    .Card__main {
        p {
            text-shadow: 0 0.0625rem 0.0625rem hsl(var(--card-shadow-color));
        }

        a {
            color: hsl(var(--card-link-color));

            &:active,
            &:visited {
                color: hsl(var(--card-link-color));
            }

            &:hover,
            &:focus {
                color: hsl(var(--card-hover-color));
            }
        }
    }
}

.Card--square {
    --card-ratio: auto 1/1;
}

.Card--photo {
    --card-ratio: auto 4/3;
}

.Card--portrait {
    --card-ratio: auto 3/4;
}

.Card--wide {
    --card-ratio: auto 16/9;
}

@supports not (aspect-ratio: 1/1) {
    .Card__media {
        height: 100%;
        padding-block-end: calc(100% * (1 / 1));
    }

    .Card--square {
        .Card__media {
            padding-block-end: calc(100% * (1 / 1));
        }
    }

    .Card--photo {
        .Card__media {
            padding-block-end: calc(100% * (3 / 4));
        }
    }

    .Card--portrait {
        .Card__media {
            padding-block-end: calc(100% * (4 / 3));
        }
    }

    .Card--wide {
        .Card__media {
            padding-block-end: calc(100% * (9 / 16));
        }
    }
}

img {
    display: block;
    height: auto;
    max-width: 100%;
}